socket = require('socket')
require('myrdb')

local alarms = {
   {'F001', 'SPS: Prozessabbruch / kein Prozessstart wegen Fehler oder Störung'},
   {'E002', 'SPS: Kühlwasser fehlt'},
   {'F003', 'SPS: Puls Einheit: Kommunikationsfehler'},
   {'E004', 'SPS: Drehantrieb steht'},
   {'W005', 'SPS: Übertemperatur Heizung H1'},
   {'W006', 'SPS: Übertemperatur Heizung H2'},
   {'W007', 'SPS: Übertemperatur Heizung H3'},
   {'W008', 'SPS: Übertemperatur Heizung H4'},
   {'F009', 'SPS: Turbopumpe P1: Sammelstörung'},
   {'F010', 'SPS: Turbopumpe P2: Sammelstörung'},
   {'E011', 'SPS: Wälzkolbenpumpe P3'},
   {'F012', 'SPS: Drehschieberpumpe P4'},
   {'W013', 'SPS: Belüftungsventil BV1 öffnet nicht'},
   {'F014', 'SPS: Hochvakuumventil HV1 öffnet nicht'},
   {'F015', 'SPS: Hochvakuumventil HV2 öffnet nicht'},
   {'F016', 'SPS: Vorvakuumventil VV1 öffnet nicht'},
   {'F017', 'SPS: Vorvakuumventil VV2 öffnet nicht'},
   {'F018', 'SPS: Grobvakuumventil GV1 öffnet nicht'},
   {'F019', 'SPS: Grobvakuumventil GV2 öffnet nicht'},
   {'F020', 'SPS: Druckluft fehlt'},
   {'F021', 'SPS: Sicherheitskette auf'},
   {'E022', 'SPS: Eingabe Maximaler Biasstrom fehlt.'},
   {'W023', 'SPS: Keine Freigabe'},
   {'E024', 'SPS: Prozessabbruch wegen StoErung in mindestens 5Min.'},
   {'M025', 'SPS: Ungenügend Kühlung Verdampfer V1A / V1B'},
   {'M026', 'SPS: Ungenügend Kühlung Verdampfer V2A / V2B'},
   {'M027', 'SPS: Ungenügend Kühlung Verdampfer V3A / V3B'},
   {'M028', 'SPS: Ungenügend Kühlung Verdampfer V4A / V4B'},
   {'M029', 'SPS: Ungenügend Kühlung Verdampfer V5A / V5B'},
   {'M030', 'SPS: Ungenügend Kühlung Verdampfer V6A / V6B'},
   {'M031', 'SPS: Ungenügend Kühlung Verdampfer V7A / V7B'},
   {'M032', 'SPS: Ungenügend Kühlung Verdampfer V8A / V8B'},
   {'M033', 'SPS: Ungenügend Kühlung Verdampfer V9A / V9B'},
   {'M034', 'SPS: Ungenügend Kühlung Verdampfer V10A / V10B'},
   {'W035', 'SPS: Kühlwasserdruck zu niedrig'},
   {'E036', 'SPS: Kammerübertemperatur'},
   {'F037', 'SPS: Biasspannung zu niedrig'},
   {'E038', 'SPS: zu viele Verdampfer gestört, Abbruchbedingung erreicht!'},
   {'E039', 'SPS: Parametrierungsfehler!'},
   {'F040', 'SPS: Biasspannung zu hoch'},
   {'W041', 'SPS: Heizung H1 arbeitet nicht'},
   {'W042', 'SPS: Heizung H2 arbeitet nicht'},
   {'W043', 'SPS: Heizung H3 arbeitet nicht'},
   {'W044', 'SPS: Heizung H4 arbeitet nicht'},
   {'W045', 'SPS: SPS Neustart'},
   {'F046', 'SPS: Störung (+/-15V= / 24V=) Versorgung'},
   {'E047', 'SPS: Übertemperatur in Biasschrank (+A5)'},
   {'E048', 'SPS: Übertemperatur in Steuerschrank (+A1)'},
   {'W049', 'SPS: Bias: Interlock 1 offen'},
   {'W050', 'SPS: Bias: Interlock 2 offen'},
   {'W051', 'SPS: Bias: Hauptschütz'},
   {'W052', 'SPS: Bias: Temperatur zu hoch'},
   {'W053', 'SPS: Bias: Interner Fehler'},
   {'W054', 'SPS: Bias: Netzspannung zu niedrig'},
   {'W055', 'SPS: Bias: Netzspannung zu hoch'},
   {'W056', 'SPS: Bias: Meldung 8'},
   {'W057', 'SPS: Bias: Kurzschluss'},
   {'W058', 'SPS: Bias: Programmierfehler'},
   {'W059', 'SPS: Bias: P-Regelungsfehler'},
   {'W060', 'SPS: Bias: U-Regelungsfehler'},
   {'W061', 'SPS: Bias: I-Regelungsfehler'},
   {'W062', 'SPS: Bias: Leistungsaufteilung fehlerhaft'},
   {'W063', 'SPS: Bias: Fehlerwort 4, Bit14'},
   {'W064', 'SPS: Bias: Fehlerwort 4, Bit15'},
   {'W065', 'SPS: Allgemeine Profibus-DP Störung'},
   {'E066', 'SPS: Verdampferschrank 1: Profibus-DP Störung'},
   {'E067', 'SPS: Verdampferschrank 2: Profibus-DP Störung'},
   {'W068', 'SPS: Kammer E/A\'s: Profibus-DP Störung'},
   {'F069', 'SPS: Feldbusknoten: Profibus-DP Störung'},
   {'F070', 'SPS: MFC N2 : Profibus-DP Störung'},
   {'F071', 'SPS: MFC CH4 : Profibus-DP Störung'},
   {'F072', 'SPS: MFC Ar-1 : Profibus-DP Störung'},
   {'F073', 'SPS: MFC H2 : Profibus-DP Störung'},
   {'F074', 'SPS: MFC Ar-2 : Profibus-DP Störung'},
   {'F075', 'SPS: Bias: Profibus-DP Störung'},
   {'W076', 'SPS: Frequenzumrichter Drehantrieb: Profibus-DP Störung'},
   {'W077', 'SPS: Master SPS S7-400 Gerätefehler'},
   {'E078', 'SPS: Übertemperatur in Verdampferschrank 1'},
   {'E079', 'SPS: Übertemperatur in Verdampferschrank 2'},
   {'F080', 'SPS: Bias-Iststrom zu klein'},
   {'F081', 'SPS: Isolationsventil IV1 öffnet nicht'},
   {'W082', 'SPS: Isolationsventil IV1 schließt nicht'},
   {'F083', 'SPS: Isolationsventil IV2 öffnet nicht'},
   {'W084', 'SPS: Isolationsventil IV2 schließt nicht'},
   {'E085', 'SPS: Hochvakuumventil HV1 schließt nicht'},
   {'E086', 'SPS: Hochvakuumventil HV2 schließt nicht'},
   {'W087', 'SPS: Vorvakuumventil VV1 schließt nicht'},
   {'W088', 'SPS: Vorvakuumventil VV2 schließt nicht'},
   {'F089', 'SPS: Grobvakuumventil GV1 schließt nicht'},
   {'F090', 'SPS: Grobvakuumventil GV2 schließt nicht'},
   {'W091', 'SPS: Belüftungsventil BV1 schließt nicht'},
   {'F092', 'SPS: Prozessdruck zu hoch'},
   {'F093', 'SPS: Prozessdruck zu niedrig'},
   {'F094', 'SPS: !! ACHTUNG !!  Servicefunktion zur Beobachtung aktiv!'},
   {'E095', 'SPS: Soll-Istabweichung N2 Fluss. Prüfe Soll- und Istwerte'},
   {'E096', 'SPS: Soll-Istabweichung CH4 Fluss. Prüfe Soll- und Istwerte'},
   {'E097', 'SPS: Soll-Istabweichung Ar-1 Fluss. Prüfe Soll- und Istwerte'},
   {'E098', 'SPS: Soll-Istabweichung H2 Fluss. Prüfe Soll- und Istwerte'},
   {'E099', 'SPS: Soll-Istabweichung Ar-2 Fluss. Prüfe Soll- und Istwerte'},
   {'M100', 'SPS: Zündfehler Verdampfer V1A'},
   {'M101', 'SPS: Zündfehler Verdampfer V1B'},
   {'M102', 'SPS: Zündfehler Verdampfer V2A'},
   {'M103', 'SPS: Zündfehler Verdampfer V2B'},
   {'M104', 'SPS: Zündfehler Verdampfer V3A'},
   {'M105', 'SPS: Zündfehler Verdampfer V3B'},
   {'M106', 'SPS: Zündfehler Verdampfer V4A'},
   {'M107', 'SPS: Zündfehler Verdampfer V4B'},
   {'M108', 'SPS: Zündfehler Verdampfer V5A'},
   {'M109', 'SPS: Zündfehler Verdampfer V5B'},
   {'M110', 'SPS: Zündfehler Verdampfer V6A'},
   {'M111', 'SPS: Zündfehler Verdampfer V6B'},
   {'M112', 'SPS: Zündfehler Verdampfer V7A'},
   {'M113', 'SPS: Zündfehler Verdampfer V7B'},
   {'M114', 'SPS: Zündfehler Verdampfer V8A'},
   {'M115', 'SPS: Zündfehler Verdampfer V8B'},
   {'M116', 'SPS: Zündfehler Verdampfer V9A'},
   {'M117', 'SPS: Zündfehler Verdampfer V9B'},
   {'M118', 'SPS: Zündfehler Verdampfer V10A'},
   {'M119', 'SPS: Zündfehler Verdampfer V10B'},
   {'M120', 'SPS: Fehler Verdampferstromquelle V1A'},
   {'M121', 'SPS: Fehler Verdampferstromquelle V1B'},
   {'M122', 'SPS: Fehler Verdampferstromquelle V2A'},
   {'M123', 'SPS: Fehler Verdampferstromquelle V2B'},
   {'M124', 'SPS: Fehler Verdampferstromquelle V3A'},
   {'M125', 'SPS: Fehler Verdampferstromquelle V3B'},
   {'M126', 'SPS: Fehler Verdampferstromquelle V4A'},
   {'M127', 'SPS: Fehler Verdampferstromquelle V4B'},
   {'M128', 'SPS: Fehler Verdampferstromquelle V5A'},
   {'M129', 'SPS: Fehler Verdampferstromquelle V5B'},
   {'M130', 'SPS: Fehler Verdampferstromquelle V6A'},
   {'M131', 'SPS: Fehler Verdampferstromquelle V6B'},
   {'M132', 'SPS: Fehler Verdampferstromquelle V7A'},
   {'M133', 'SPS: Fehler Verdampferstromquelle V7B'},
   {'M134', 'SPS: Fehler Verdampferstromquelle V8A'},
   {'M135', 'SPS: Fehler Verdampferstromquelle V8B'},
   {'M136', 'SPS: Fehler Verdampferstromquelle V9A'},
   {'M137', 'SPS: Fehler Verdampferstromquelle V9B'},
   {'M138', 'SPS: Fehler Verdampferstromquelle V10A'},
   {'M139', 'SPS: Fehler Verdampferstromquelle V10B'},
   {'M140', 'SPS: Kurzschluss Verdampfer V1A'},
   {'M141', 'SPS: Kurzschluss Verdampfer V1B'},
   {'M142', 'SPS: Kurzschluss Verdampfer V2A'},
   {'M143', 'SPS: Kurzschluss Verdampfer V2B'},
   {'M144', 'SPS: Kurzschluss Verdampfer V3A'},
   {'M145', 'SPS: Kurzschluss Verdampfer V3B'},
   {'M146', 'SPS: Kurzschluss Verdampfer V4A'},
   {'M147', 'SPS: Kurzschluss Verdampfer V4B'},
   {'M148', 'SPS: Kurzschluss Verdampfer V5A'},
   {'M149', 'SPS: Kurzschluss Verdampfer V5B'},
   {'M150', 'SPS: Kurzschluss Verdampfer V6A'},
   {'M151', 'SPS: Kurzschluss Verdampfer V6B'},
   {'M152', 'SPS: Kurzschluss Verdampfer V7A'},
   {'M153', 'SPS: Kurzschluss Verdampfer V7B'},
   {'M154', 'SPS: Kurzschluss Verdampfer V8A'},
   {'M155', 'SPS: Kurzschluss Verdampfer V8B'},
   {'M156', 'SPS: Kurzschluss Verdampfer V9A'},
   {'M157', 'SPS: Kurzschluss Verdampfer V9B'},
   {'M158', 'SPS: Kurzschluss Verdampfer V10A'},
   {'M159', 'SPS: Kurzschluss Verdampfer V10B'},
   {'W160', 'SPS: Lasttrennschütz -4K1 schließt nicht'},
   {'W161', 'SPS: Lasttrennschütz -4K1 öffnet nicht'},
   {'W162', 'SPS: N2 Ventil öffnet nicht'},
   {'W163', 'SPS: CH4 Ventil öffnet nicht'},
   {'W164', 'SPS: Ar-1 Ventil öffnet nicht'},
   {'W165', 'SPS: H2 Ventil öffnet nicht'},
   {'W166', 'SPS: Ar-2 Ventil öffnet nicht'},
   {'V167', 'SPS: Vorlaufübertemperatur Kühlwasser Verdampfer'},
   {'W168', 'SPS: Autozero Baratron (A4) fehlgeschlagen'},
   {'W169', 'SPS: Übertemperatur in PC-Schrank'},
   {'W170', 'SPS: Ungenügend Kühlung an Turbopumpe / Drehdurchführung'},
   {'W171', 'SPS: Kurzschluss Bias'},
   {'F172', 'SPS: Netzspannungsstörung Steuerschrank'},
   {'E173', 'SPS: Netzspannungsstörung Biasschrank'},
   {'E174', 'SPS: Netzspannungsstörung Verdampferschrank 1'},
   {'E175', 'SPS: Netzspannungsstörung Verdampferschrank 2'},
   {'W176', 'SPS: Antriebselektronik Turbopumpe P1: Profibus Störung'},
   {'M177', 'SPS: Ungenügend Kühlung Verdampfer V11A / V11B'},
   {'M178', 'SPS: Ungenügend Kühlung Verdampfer V12A / V12B'},
   {'M179', 'SPS: Zündfehler Verdampfer V11A'},
   {'M180', 'SPS: Zündfehler Verdampfer V11B'},
   {'M181', 'SPS: Zündfehler Verdampfer V12A'},
   {'M182', 'SPS: Zündfehler Verdampfer V12B'},
   {'M183', 'SPS: Fehler Verdampferstromquelle V11A'},
   {'M184', 'SPS: Fehler Verdampferstromquelle V11B'},
   {'M185', 'SPS: Fehler Verdampferstromquelle V12A'},
   {'M186', 'SPS: Fehler Verdampferstromquelle V12B'},
   {'M187', 'SPS: Kurzschluss Verdampfer V11A'},
   {'M188', 'SPS: Kurzschluss Verdampfer V11B'},
   {'M189', 'SPS: Kurzschluss Verdampfer V12A'},
   {'M190', 'SPS: Kurzschluss Verdampfer V12B'},
   {'W191', 'SPS: Antriebselektronik Turbopumpe P2: Profibus Störung'},
   {'E192', 'SPS: Störung Kühlgerät CT9 / CT14 / T12'},
   {'M193', 'SPS: Zündfehler Verdampfer V15A'},
   {'M194', 'SPS: Zündfehler Verdampfer V15B'},
   {'M195', 'SPS: Zündfehler Verdampfer V16A'},
   {'M196', 'SPS: Zündfehler Verdampfer V16B'},
   {'M197', 'SPS: Fehler Verdampferstromquelle V13A'},
   {'M198', 'SPS: Fehler Verdampferstromquelle V13B'},
   {'M199', 'SPS: Fehler Verdampferstromquelle V14A'},
   {'M200', 'SPS: Fehler Verdampferstromquelle V14B'},
   {'M201', 'SPS: Ungenügend Kühlung Verdampfer V13A / V13B'},
   {'M202', 'SPS: Ungenügend Kühlung Verdampfer V14A / V14B'},
   {'M203', 'SPS: Ungenügend Kühlung Verdampfer V15A / V15B'},
   {'M204', 'SPS: Ungenügend Kühlung Verdampfer V16A / V16B'},
   {'M205', 'SPS: Zündfehler Verdampfer V13A'},
   {'M206', 'SPS: Zündfehler Verdampfer V13B'},
   {'M207', 'SPS: Zündfehler Verdampfer V14A'},
   {'M208', 'SPS: Zündfehler Verdampfer V14B'},
   {'M209', 'SPS: Kurzschluss Verdampfer V15A'},
   {'M210', 'SPS: Kurzschluss Verdampfer V15B'},
   {'M211', 'SPS: Kurzschluss Verdampfer V16A'},
   {'M212', 'SPS: Kurzschluss Verdampfer V16B'},
   {'E213', 'SPS: Übertemperatur in Verdampferschrank 3'},
   {'E214', 'SPS: Netzspannungsstörung Verdampferschrank 3'},
   {'E215', 'SPS: Verdampferschrank 3: Profibus-DP Störung'},
   {'W216', 'SPS: Übertemperatur am Pumpstand'},
   {'M217', 'SPS: Fehler Verdampferstromquelle V15A'},
   {'M218', 'SPS: Fehler Verdampferstromquelle V15B'},
   {'M219', 'SPS: Fehler Verdampferstromquelle V16A'},
   {'M220', 'SPS: Fehler Verdampferstromquelle V16B'},
   {'M221', 'SPS: Kurzschluss Verdampfer V13A'},
   {'M222', 'SPS: Kurzschluss Verdampfer V13B'},
   {'M223', 'SPS: Kurzschluss Verdampfer V14A'},
   {'M224', 'SPS: Kurzschluss Verdampfer V14B'},
   {'W225', 'SPS: Turbopumpe P1 Fehlermeldung 001 Überdrehzahl TMP'},
   {'W226', 'SPS: Turbopumpe P1 Fehlermeldung 002 Netzteilfehler'},
   {'W227', 'SPS: Turbopumpe P1 Fehlermeldung 006 Anlaufzeitfehler'},
   {'W228', 'SPS: Turbopumpe P1 Fehlermeldung 007 Betriebsmittelmangel'},
   {'W229', 'SPS: Turbopumpe P1 Fehlermeldung 008 Verbindung TC'},
   {'W230', 'SPS: Turbopumpe P1 Fehlermeldung 014 Heizungstyp verändert'},
   {'W231', 'SPS: Turbopumpe P1 Fehlermeldung 015 TC Controllerfehler'},
   {'W232', 'SPS: Turbopumpe P1 Fehlermeldung 021 Falscher Pumpenwiderstand'},
   {'W233', 'SPS: Turbopumpe P1 Fehlermeldung 037 Motorstufe bzw. Ansteuerung gestört'},
   {'W234', 'SPS: Turbopumpe P1 Fehlermeldung 698 TC Antwortet nicht'},
   {'W235', 'SPS: Turbopumpe P1 Fehlermeldung 913 Selbsttest bzw. Anlauf gestört'},
   {'W236', 'SPS: Fehlerwort 15'},
   {'W237', 'SPS: Fehlerwort 15'},
   {'W238', 'SPS: Fehlerwort 15'},
   {'W239', 'SPS: Fehlerwort 15'},
   {'W240', 'SPS: Turbopumpe P1 Fehlermeldung xxx Unbekannter Fehler aufgetreten'},
   {'W241', 'SPS: Turbopumpe P2 Fehlermeldung 001 Überdrehzahl TMP'},
   {'W242', 'SPS: Turbopumpe P2 Fehlermeldung 002 Netzteilfehler'},
   {'W243', 'SPS: Turbopumpe P2 Fehlermeldung 006 Anlaufzeitfehler'},
   {'W244', 'SPS: Turbopumpe P2 Fehlermeldung 007 Betriebsmittelmangel'},
   {'W245', 'SPS: Turbopumpe P2 Fehlermeldung 008 Verbindung TC'},
   {'W246', 'SPS: Turbopumpe P2 Fehlermeldung 014 Heizungstyp verändert'},
   {'W247', 'SPS: Turbopumpe P2 Fehlermeldung 015 TC Controllerfehler'},
   {'W248', 'SPS: Turbopumpe P2 Fehlermeldung 021 Falscher Pumpenwiderstand'},
   {'W249', 'SPS: Turbopumpe P2 Fehlermeldung 037 Motorstufe bzw. Ansteuerung gestört'},
   {'W250', 'SPS: Turbopumpe P2 Fehlermeldung 698 TC Antwortet nicht'},
   {'W251', 'SPS: Turbopumpe P2 Fehlermeldung 913 Selbsttest bzw. Anlauf gestört'},
   {'W252', 'SPS: Fehlerwort 16'},
   {'W253', 'SPS: Fehlerwort 16'},
   {'W254', 'SPS: Fehlerwort 16'},
   {'W255', 'SPS: Fehlerwort 16'},
   {'W256', 'SPS: Turbopumpe P2 Fehlermeldung xxx Unbekannter Fehler aufgetreten'},
   {'W257', 'SPS: Turbopumpe P1 Warnmeldung 001 TMS Aufheizzeit abgelaufen'},
   {'W258', 'SPS: Turbopumpe P1 Warnmeldung 002 TMS Grenztemperatur'},
   {'W259', 'SPS: Turbopumpe P1 Warnmeldung 003 TMS Heizkreis Temperatursensor'},
   {'W260', 'SPS: Turbopumpe P1 Warnmeldung 007 Netzausfall'},
   {'W261', 'SPS: Turbopumpe P1 Warnmeldung 039 Schutzleiterwarnung TC !!'},
   {'W262', 'SPS: Turbopumpe P1 Warnmeldung 110 Druckmessröhre fehlerhaft'},
   {'W263', 'SPS: Fehlerwort 17'},
   {'W264', 'SPS: Turbopumpe P1 Warnmeldung xxx Unbekannte Warnung aufgetreten'},
   {'W265', 'SPS: Turbopumpe P2 Warnmeldung 001 TMS Aufheizzeit abgelaufen'},
   {'W266', 'SPS: Turbopumpe P2 Warnmeldung 002 TMS Grenztemperatur'},
   {'W267', 'SPS: Turbopumpe P2 Warnmeldung 003 TMS Heizkreis Temperatursensor'},
   {'W268', 'SPS: Turbopumpe P2 Warnmeldung 007 Netzausfall'},
   {'W269', 'SPS: Turbopumpe P2 Warnmeldung 039 Schutzleiterwarnung TC !!'},
   {'W270', 'SPS: Turbopumpe P2 Warnmeldung 110 Druckmessröhre fehlerhaft'},
   {'W271', 'SPS: Fehlerwort 17'},
   {'W272', 'SPS: Turbopumpe P2 Warnmeldung xxx Unbekannte Warnung aufgetreten'},
   {'W273', 'SPS: Verdampfer V1A / V1B: Durchfluss-Sensor hängt'},
   {'W274', 'SPS: Verdampfer V2A / V2B: Durchfluss-Sensor hängt'},
   {'W275', 'SPS: Verdampfer V3A / V3B: Durchfluss-Sensor hängt'},
   {'W276', 'SPS: Verdampfer V4A / V4B: Durchfluss-Sensor hängt'},
   {'W277', 'SPS: Verdampfer V5A / V5B: Durchfluss-Sensor hängt'},
   {'W278', 'SPS: Verdampfer V6A / V6B: Durchfluss-Sensor hängt'},
   {'W279', 'SPS: Verdampfer V7A / V7B: Durchfluss-Sensor hängt'},
   {'W280', 'SPS: Verdampfer V8A / V8B: Durchfluss-Sensor hängt'},
   {'W281', 'SPS: Verdampfer V9A / V9B: Durchfluss-Sensor hängt'},
   {'W282', 'SPS: Verdampfer V10A / V10B: Durchfluss-Sensor hängt'},
   {'W283', 'SPS: Verdampfer V11A / V11B: Durchfluss-Sensor hängt'},
   {'W284', 'SPS: Verdampfer V12A / V12B: Durchfluss-Sensor hängt'},
   {'W285', 'SPS: Verdampfer V13A / V13B: Durchfluss-Sensor hängt'},
   {'W286', 'SPS: Verdampfer V14A / V14B: Durchfluss-Sensor hängt'},
   {'W287', 'SPS: Verdampfer V15A / V15B: Durchfluss-Sensor hängt'},
   {'W288', 'SPS: Verdampfer V16A / V16B: Durchfluss-Sensor hängt'},
   {'W289', 'SPS: N2 Ventil schließt nicht'},
   {'W290', 'SPS: CH4 Ventil schließt nicht'},
   {'W291', 'SPS: Ar-1 Ventil schließt nicht'},
   {'W292', 'SPS: H2 Ventil schließt nicht'},
   {'W293', 'SPS: Ar-2 Ventil schließt nicht'},
   {'W294', 'SPS: Pyrometer: Profibus-DP Störung'},
   {'W295', 'SPS: Drehimpulsgeber: Profibus-DP Störung'},
   {'E296', 'SPS: I/O System 1 Verdampferschrank 1: PB  interne Störung'},
   {'E297', 'SPS: I/O System 2 Verdampferschrank 2: PB  interne Störung'},
   {'W298', 'SPS: ET200 (M/LS): PB  interne Störung'},
   {'W299', 'SPS: Drehantrieb Frequenzumrichter: PB  interne Störung'},
   {'F300', 'SPS: Ventilinsel: PB  interne Störung'},
   {'F301', 'SPS: Bias: PB  interne Störung'},
   {'W302', 'SPS: MFC N2 : PB  interne Störung'},
   {'W303', 'SPS: MFC CH4 : PB  interne Störung'},
   {'W304', 'SPS: MFC Ar-1 : PB  interne Störung'},
   {'W305', 'SPS: MFC H2 : PB  interne Störung'},
   {'W306', 'SPS: MFC Ar-2 : PB  interne Störung'},
   {'W307', 'SPS: TC Turbopumpe P1: PB  interne Störung'},
   {'W308', 'SPS: TC Turbopumpe P2: PB  interne Störung'},
   {'W309', 'SPS: Pyrometer: PB  interne Störung'},
   {'E310', 'SPS: I/O System 3 Verdampferschrank 3: PB  interne Störung'},
   {'W311', 'SPS: Drehimpulsgeber: PB  interne Störung'},
   {'W312', 'SPS: Vorvakuumdruck zu hoch!'},
   {'W313', 'SPS: !!! ACHTUNG Belüften wurde bei Heiz.temp.>150°C aktiviert !!!'},
   {'W314', 'SPS: Vakuummeßröhre A1 defekt !'},
   {'W315', 'SPS: Vakuummeßröhre A2 defekt !'},
   {'W316', 'SPS: Vakuummeßröhre A3 defekt !'},
   {'W317', 'SPS: Vakuummeßröhre A4 defekt !'},
   {'W318', 'SPS: Vakuumschalter defekt !'},
   {'W319', 'SPS: Heizungsregler gestört, Heizungstemperatur kann fehlerhaft sein!'},
   {'W320', 'SPS: Offsetwerte fehlen !'},
   {'E321', 'SPS: Pulser Übertemperatur'},
   {'E322', 'SPS: Pulser Überstrom'},
   {'E323', 'SPS: Pulser Störung'},
   {'W324', 'SPS: Biasspannung Sollwert zu hoch'},
   {'W325', 'SPS: Biasstrom Sollwert zu hoch'},
   {'W326', 'SPS: Polycold Störung'},
   {'W327', 'SPS: Verdampfer Betriebsspannung erhöht!'},
   {'W328', 'SPS: Turbopumpe Fehlermeldung von Turboguard: gelb'},
   {'W329', 'SPS: Turbopumpe Fehlermeldung von Turboguard: rot'},
   {'E330', 'SPS: !!! ACHTUNG Phasenfehler in der Zuleitung !!!'},
   {'W331', 'SPS: !!! ACHTUNG min. eine Pufferbatterie der SPS ist leer (BATTF) !!!'},
   {'W332', 'SPS: !!! ACHTUNG Pufferspannung in der SPS fehlt (BAF) !!!'},
   {'M333', 'SPS: Ungenügend Kühlung Verdampfer V1A / V1B / V2A'},
   {'M334', 'SPS: Ungenügend Kühlung Verdampfer V2B / V3A / V3B'},
   {'M335', 'SPS: Verdampfer V1A / V1B / V2A: Durchfluss-Sensor hängt'},
   {'M336', 'SPS: Verdampfer V2B / V3A / V3B: Durchfluss-Sensor hängt'},
   {'W337', 'SPS: MDXII Analog nach Digital Fehler'},
   {'W338', 'SPS: MDXII Übertemperatur'},
   {'W339', 'SPS: MDXII Interlock 1 Fehler'},
   {'W340', 'SPS: MDXII kurzzeitiger Power Fehler'},
   {'W341', 'SPS: MDXII Busfehler'},
   {'W342', 'SPS: MDXII Profibusinterface Fehler'},
   {'W343', 'SPS: MDXII Gerätehauptschalter aus und einschalten !!!'},
   {'E344', 'SPS: TC1 + TC2 defekt, Regelung nicht möglich !!!'},
   {'W345', 'SPS: Kühlwasserdruck zu niedrig (Kreis 2)'},
   {'E346', 'SPS: Kurzschluss Basisflansch links  / Kammer         [F=W346+W348]'},
   {'E347', 'SPS: Kurzschluss Basisflansch rechts / Kammer         [F=W347+W349]'},
   {'W348', 'SPS: Kurzschluss Basisflansch links  / Verdampfer     [F=W348+W349]'},
   {'W349', 'SPS: Kurzschluss Basisflansch rechts / Verdampfer     [F=W348+W349]'},
   {'W350', 'SPS: Druckluft zu niedrig (Warnung)'},
   {'W351', 'SPS: N2 Regeloffset max. erreicht'},
   {'W352', 'SPS: N2 Regeloffset min. erreicht'},
   {'E353', 'SPS: Zündfehler Plasmaquelle 1'},
   {'E354', 'SPS: Zündfehler Plasmaquelle 2'},
   {'E355', 'SPS: Fehler an  Plasmaquelle AC 1'},
   {'E356', 'SPS: Fehler an  Plasmaquelle DC 1'},
   {'E357', 'SPS: Fehler an  Plasmaquelle AC 2'},
   {'E358', 'SPS: Fehler an  Plasmaquelle DC 2'},
   {'E359', 'SPS: Kurzschluss Plasmaquelle AC 1'},
   {'E360', 'SPS: Kurzschluss Plasmaquelle DC 1'},
   {'E361', 'SPS: Kurzschluss Plasmaquelle AC 2'},
   {'E362', 'SPS: Kurzschluss Plasmaquelle DC 2'},
   {'E363', 'SPS: Ungenügend Kühlung Plasmaanode 1'},
   {'E364', 'SPS: Ungenügend Kühlung Plasmaanode 2'},
   {'E365', 'SPS: Ungenügend Kühlung Plasmaquelle'},
   {'W366', 'SPS: Durchfluss-Sensor hängt Plasmaanode 1'},
   {'W367', 'SPS: Durchfluss-Sensor hängt Plasmaanode 2'},
   {'W368', 'SPS: Durchfluss-Sensor hängt Plasmaquelle'},
   {'E369', 'SPS: Erdungsschütz zieht nicht an'},
   {'E370', 'SPS: Erdungsschütz fällt nicht ab'},
   {'E371', 'SPS: Anodenschütz zieht nicht an'},
   {'E372', 'SPS: Anodenschütz fällt nicht ab'},
   {'W373', 'SPS: Motorschutzstör. Trigger AC1 (DC2)'},
   {'W374', 'SPS: Motorschutzstör. Trigger AC2 (DC1)'},
   {'E375', 'SPS: Temperatur Plasmaquellen nicht im Bereich'},
   {'W376', 'SPS: PQ DC1 Fehler: OVP (Überspannung)'},
   {'W377', 'SPS: PQ DC1 Fehler: Power Fail (Temp.abschaltung)'},
   {'W378', 'SPS: PQ DC1 Fehler: Übertemperaturwarnung'},
   {'W379', 'SPS: PQ DC2 Fehler: OVP (Überspannung)'},
   {'W380', 'SPS: PQ DC2 Fehler: Power Fail (Temp.abschaltung)'},
   {'W381', 'SPS: PQ DC2 Fehler: Übertemperaturwarnung'},
   {'F382', 'SPS: N2 abgeschaltet! Weil ...'},
   {'F383', 'SPS: Ar-1 abgeschaltet! Weil ...'},
   {'F384', 'SPS: Ar-2 abgeschaltet! Weil ...'},
   {'F385', 'SPS: MFC Ar-3 : Profibus-DP Störung'},
   {'W386', 'SPS: MFC Ar-3 : PB  interne Störung'},
   {'W387', 'SPS: Soll-Istabweichung Ar-3 Fluss. Prüfe Soll- und Istwerte'},
   {'W388', 'SPS: Ar-3 Ventil öffnet nicht'},
   {'W389', 'SPS: Ar-3 Ventil schließt nicht'},
   {'F390', 'SPS: MFC H2 : Profibus-DP Störung'},
   {'W391', 'SPS: MFC H2 : PB  interne Störung'},
   {'W392', 'SPS: Soll-Istabweichung H2 Fluss. Prüfe Soll- und Istwerte'},
   {'W393', 'SPS: H2 Ventil öffnet nicht'},
   {'W394', 'SPS: H2 Ventil schließt nicht'},
   {'F395', 'SPS: H2 abgeschaltet, Weil Ar-2 aus oder Fluss zu gering ist.'},
   {'F396', 'SPS: H2 abgeschaltet, Weil Ar-1 aus oder Fluss zu gering ist.'},
   {'F397', 'SPS: CH4  abgeschaltet! Weil AUX  ein.'},
   {'F398', 'SPS: AUX  abgeschaltet! Weil H2  ein oder CH4  ein'},
   {'E399', 'SPS: Shutterposition fehlerhaft'},
   {'E400', 'SPS: Ungenügend Kühlung Kammer (li. / re. / Tür)'},
   {'W401', 'SPS: Verdampfer V1A Strom Soll-Istabweichung. Prüfe Soll- und Istwerte'},
   {'W402', 'SPS: Verdampfer V1B Strom Soll-Istabweichung. Prüfe Soll- und Istwerte'},
   {'W403', 'SPS: Verdampfer V2A Strom Soll-Istabweichung. Prüfe Soll- und Istwerte'},
   {'W404', 'SPS: Verdampfer V2B Strom Soll-Istabweichung. Prüfe Soll- und Istwerte'},
   {'W405', 'SPS: Verdampfer V3A Strom Soll-Istabweichung. Prüfe Soll- und Istwerte'},
   {'W406', 'SPS: Verdampfer V3B Strom Soll-Istabweichung. Prüfe Soll- und Istwerte'},
   {'W407', 'SPS: Verdampfer V4A Strom Soll-Istabweichung. Prüfe Soll- und Istwerte'},
   {'W408', 'SPS: Verdampfer V4B Strom Soll-Istabweichung. Prüfe Soll- und Istwerte'},
   {'W409', 'SPS: Verdampfer V5A Strom Soll-Istabweichung. Prüfe Soll- und Istwerte'},
   {'W410', 'SPS: Verdampfer V5B Strom Soll-Istabweichung. Prüfe Soll- und Istwerte'},
   {'W411', 'SPS: Verdampfer V6A Strom Soll-Istabweichung. Prüfe Soll- und Istwerte'},
   {'W412', 'SPS: Verdampfer V6B Strom Soll-Istabweichung. Prüfe Soll- und Istwerte'},
   {'W413', 'SPS: Verdampfer V7A Strom Soll-Istabweichung. Prüfe Soll- und Istwerte'},
   {'W414', 'SPS: Verdampfer V7B Strom Soll-Istabweichung. Prüfe Soll- und Istwerte'},
   {'W415', 'SPS: Verdampfer V8A Strom Soll-Istabweichung. Prüfe Soll- und Istwerte'},
   {'W416', 'SPS: Verdampfer V8B Strom Soll-Istabweichung. Prüfe Soll- und Istwerte'},
   {'W417', 'SPS: Verdampfer V9A Strom Soll-Istabweichung. Prüfe Soll- und Istwerte'},
   {'W418', 'SPS: Verdampfer V9B Strom Soll-Istabweichung. Prüfe Soll- und Istwerte'},
   {'W419', 'SPS: Verdampfer V10A Strom Soll-Istabweichung. Prüfe Soll- und Istwerte'},
   {'W420', 'SPS: Verdampfer V10B Strom Soll-Istabweichung. Prüfe Soll- und Istwerte'},
   {'W421', 'SPS: Verdampfer V11A Strom Soll-Istabweichung. Prüfe Soll- und Istwerte'},
   {'W422', 'SPS: Verdampfer V11B Strom Soll-Istabweichung. Prüfe Soll- und Istwerte'},
   {'W423', 'SPS: Verdampfer V12A Strom Soll-Istabweichung. Prüfe Soll- und Istwerte'},
   {'W424', 'SPS: Verdampfer V12B Strom Soll-Istabweichung. Prüfe Soll- und Istwerte'},
   {'W425', 'SPS: Verdampfer V13A Strom Soll-Istabweichung. Prüfe Soll- und Istwerte'},
   {'W426', 'SPS: Verdampfer V13B Strom Soll-Istabweichung. Prüfe Soll- und Istwerte'},
   {'W427', 'SPS: Verdampfer V14A Strom Soll-Istabweichung. Prüfe Soll- und Istwerte'},
   {'W428', 'SPS: Verdampfer V14B Strom Soll-Istabweichung. Prüfe Soll- und Istwerte'},
   {'W429', 'SPS: Verdampfer V15A Strom Soll-Istabweichung. Prüfe Soll- und Istwerte'},
   {'W430', 'SPS: Verdampfer V15B Strom Soll-Istabweichung. Prüfe Soll- und Istwerte'},
   {'W431', 'SPS: Verdampfer V16A Strom Soll-Istabweichung. Prüfe Soll- und Istwerte'},
   {'W432', 'SPS: Verdampfer V16B Strom Soll-Istabweichung. Prüfe Soll- und Istwerte'},
   {'M433', 'SPS: Verdampfer V1A Spannung zu hoch! (evtl. Kurzschluss)'},
   {'M434', 'SPS: Verdampfer V1B Spannung zu hoch! (evtl. Kurzschluss)'},
   {'M435', 'SPS: Verdampfer V2A Spannung zu hoch! (evtl. Kurzschluss)'},
   {'M436', 'SPS: Verdampfer V2B Spannung zu hoch! (evtl. Kurzschluss)'},
   {'M437', 'SPS: Verdampfer V3A Spannung zu hoch! (evtl. Kurzschluss)'},
   {'M438', 'SPS: Verdampfer V3B Spannung zu hoch! (evtl. Kurzschluss)'},
   {'M439', 'SPS: Verdampfer V4A Spannung zu hoch! (evtl. Kurzschluss)'},
   {'M440', 'SPS: Verdampfer V4B Spannung zu hoch! (evtl. Kurzschluss)'},
   {'M441', 'SPS: Verdampfer V5A Spannung zu hoch! (evtl. Kurzschluss)'},
   {'M442', 'SPS: Verdampfer V5B Spannung zu hoch! (evtl. Kurzschluss)'},
   {'M443', 'SPS: Verdampfer V6A Spannung zu hoch! (evtl. Kurzschluss)'},
   {'M444', 'SPS: Verdampfer V6B Spannung zu hoch! (evtl. Kurzschluss)'},
   {'M445', 'SPS: Verdampfer V7A Spannung zu hoch! (evtl. Kurzschluss)'},
   {'M446', 'SPS: Verdampfer V7B Spannung zu hoch! (evtl. Kurzschluss)'},
   {'M447', 'SPS: Verdampfer V8A Spannung zu hoch! (evtl. Kurzschluss)'},
   {'M448', 'SPS: Verdampfer V8B Spannung zu hoch! (evtl. Kurzschluss)'},
   {'M449', 'SPS: Verdampfer V9A Spannung zu hoch! (evtl. Kurzschluss)'},
   {'M450', 'SPS: Verdampfer V9B Spannung zu hoch! (evtl. Kurzschluss)'},
   {'M451', 'SPS: Verdampfer V10A Spannung zu hoch! (evtl. Kurzschluss)'},
   {'M452', 'SPS: Verdampfer V10B Spannung zu hoch! (evtl. Kurzschluss)'},
   {'M453', 'SPS: Verdampfer V11A Spannung zu hoch! (evtl. Kurzschluss)'},
   {'M454', 'SPS: Verdampfer V11B Spannung zu hoch! (evtl. Kurzschluss)'},
   {'M455', 'SPS: Verdampfer V12A Spannung zu hoch! (evtl. Kurzschluss)'},
   {'M456', 'SPS: Verdampfer V12B Spannung zu hoch! (evtl. Kurzschluss)'},
   {'M457', 'SPS: Verdampfer V13A Spannung zu hoch! (evtl. Kurzschluss)'},
   {'M458', 'SPS: Verdampfer V13B Spannung zu hoch! (evtl. Kurzschluss)'},
   {'M459', 'SPS: Verdampfer V14A Spannung zu hoch! (evtl. Kurzschluss)'},
   {'M460', 'SPS: Verdampfer V14B Spannung zu hoch! (evtl. Kurzschluss)'},
   {'M461', 'SPS: Verdampfer V15A Spannung zu hoch! (evtl. Kurzschluss)'},
   {'M462', 'SPS: Verdampfer V15B Spannung zu hoch! (evtl. Kurzschluss)'},
   {'M463', 'SPS: Verdampfer V16A Spannung zu hoch! (evtl. Kurzschluss)'},
   {'M464', 'SPS: Verdampfer V16B Spannung zu hoch! (evtl. Kurzschluss)'},
   {'W465', 'SPS: Verdampfer V1B V1A Stromsollwert zu hoch! (Wurde angepasst!)'},
   {'W466', 'SPS: Verdampfer V2B V2A Stromsollwert zu hoch! (Wurde angepasst!)'},
   {'W467', 'SPS: Verdampfer V3B V3A Stromsollwert zu hoch! (Wurde angepasst!)'},
   {'W468', 'SPS: Verdampfer V4B V4A Stromsollwert zu hoch! (Wurde angepasst!)'},
   {'W469', 'SPS: Verdampfer V5B V5A Stromsollwert zu hoch! (Wurde angepasst!)'},
   {'W470', 'SPS: Verdampfer V6B V6A Stromsollwert zu hoch! (Wurde angepasst!)'},
   {'W471', 'SPS: Verdampfer V7B V7A Stromsollwert zu hoch! (Wurde angepasst!)'},
   {'W472', 'SPS: Verdampfer V8B V8A Stromsollwert zu hoch! (Wurde angepasst!)'},
   {'W473', 'SPS: Verdampfer V9B V9A Stromsollwert zu hoch! (Wurde angepasst!)'},
   {'W474', 'SPS: Verdampfer V10B V10A Stromsollwert zu hoch! (Wurde angepasst!)'},
   {'W475', 'SPS: Verdampfer V11B V11A Stromsollwert zu hoch! (Wurde angepasst!)'},
   {'W476', 'SPS: Verdampfer V12B V12A Stromsollwert zu hoch! (Wurde angepasst!)'},
   {'W477', 'SPS: Verdampfer V13B V13A Stromsollwert zu hoch! (Wurde angepasst!)'},
   {'W478', 'SPS: Verdampfer V14B V14A Stromsollwert zu hoch! (Wurde angepasst!)'},
   {'W479', 'SPS: Verdampfer V15B V15A Stromsollwert zu hoch! (Wurde angepasst!)'},
   {'W480', 'SPS: Verdampfer V16B V16A Stromsollwert zu hoch! (Wurde angepasst!)'},
   {'F481', 'SPS: MFC AUX : Profibus-DP Störung'},
   {'W482', 'SPS: MFC AUX : PB  interne Störung'},
   {'W483', 'SPS: Soll-Istabweichung AUX Fluss. Prüfe Soll- und Istwerte'},
   {'W484', 'SPS: AUX Ventil öffnet nicht'},
   {'W485', 'SPS: AUX Ventil schließt nicht'},
   {'W486', 'SPS: AUX abgeschaltet! Weil ...'},
   {'W487', 'SPS: Eurothermregler PlasHeiz A: Profibus-DP Störung'},
   {'W488', 'SPS: Eurothermregler PlasHeiz A: PB  interne Störung'},
   {'W489', 'SPS: Eurothermregler PlasHeiz B: Profibus-DP Störung'},
   {'W490', 'SPS: Eurothermregler PlasHeiz B: PB  interne Störung'},
   {'E491', 'SPS: Kurzschluss Basisflansch vorne  / Kammer         [F=W491+W493]'},
   {'E492', 'SPS: Kurzschluss Basisflansch hinten / Kammer         [F=W492+W494]'},
   {'W493', 'SPS: Kurzschluss Basisflansch vorne  / Verdampfer     [F=W493+W494]'},
   {'W494', 'SPS: Kurzschluss Basisflansch hinten / Verdampfer     [F=W493+W494]'},
   {'W495', 'SPS: !!! ACHTUNG Belüften wurde bei Kammertemp. <30°C aktiviert'},
   {'W496', 'SPS: Drehdurchführungsventil öffnet nicht'},
   {'W497', 'SPS: Drehdurchführungsventil schließt nicht'},
   {'W498', 'SPS: Drehdurchführung nicht eingekuppelt'},
   {'W499', 'SPS: Bypassrelais Heiz.reinigung Triggertest hängt!'},
   {'E500', 'SPS: eines der SPCS Ventile öffnet nicht'},
   {'E501', 'SPS: Reinigungsrezept: N2-Fluss zu niedrig im druckgeregelten Modus.'},
   {'E502', 'SPS: Reinigungsrezept: CH4-Fluss zu niedrig im druckgeregelten Modus.'},
   {'E503', 'SPS: Reinigungsrezept: Ar-1-Fluss zu niedrig im druckgeregelten Modus.'},
   {'E504', 'SPS: Reinigungsrezept: H2-Fluss zu niedrig im druckgeregelten Modus.'},
   {'E505', 'SPS: Reinigungsrezept: Ar-2-Fluss zu niedrig im druckgeregelten Modus.'},
   {'E506', 'SPS: Reinigungsrezept: Ar-3-Fluss zu niedrig im druckgeregelten Modus.'},
   {'E507', 'SPS: Reinigungsrezept: H2-Fluss zu niedrig im druckgeregelten Modus.'},
   {'E508', 'SPS: Reinigungsrezept: AUX-Fluss zu niedrig im druckgeregelten Modus.'},
   {'W509', 'SPS: Hohlkathode Shutter öffnet nicht'},
   {'W510', 'SPS: Hohlkathode Shutter schließt nicht'},
   {'E511', 'SPS: eines der SPCS Ventile schließt nicht'},
   {'F512', 'SPS: Der Hauptschalter wird ausgeschaltet, Temp. ist zu hoch!'},
   {'W513', 'PC: Rechner eingeschaltet oder Neustart AlphaControl.....................'},
   {'F514', 'PC: Keine Verbindung zur SPS'},
   {'W515', 'PC: Ar-2 abgeschaltet'},
   {'W516', 'PC: Bias abgeschaltet'},
   {'W517', 'PC: N2 abgeschaltet'},
   {'W518', 'PC: CH4 abgeschaltet'},
   {'W519', 'PC: Ar-1 abgeschaltet'},
   {'W520', 'PC: H2 abgeschaltet'},
   {'W521', 'PC: Heizung H1 abgeschaltet'},
   {'W522', 'PC: Heizung H2 abgeschaltet'},
   {'W523', 'PC: Heizung H3 abgeschaltet'},
   {'W524', 'PC: Heizung H4 abgeschaltet'},
   {'W525', 'PC: Reserve Meldung 1'},
   {'W526', 'PC: Reserve Meldung 2'},
   {'W527', 'PC: Reserve Meldung 3'},
   {'W528', 'PC: Drehantrieb abgeschaltet'},
   {'W529', 'PC: Verdampfer V1A abgeschaltet'},
   {'W530', 'PC: Verdampfer V1B abgeschaltet'},
   {'W531', 'PC: Verdampfer V2A abgeschaltet'},
   {'W532', 'PC: Verdampfer V2B abgeschaltet'},
   {'W533', 'PC: Verdampfer V3A abgeschaltet'},
   {'W534', 'PC: Verdampfer V3B abgeschaltet'},
   {'W535', 'PC: Verdampfer V4A abgeschaltet'},
   {'W536', 'PC: Verdampfer V4B abgeschaltet'},
   {'W537', 'PC: Verdampfer V5A abgeschaltet'},
   {'W538', 'PC: Verdampfer V5B abgeschaltet'},
   {'W539', 'PC: Verdampfer V6A abgeschaltet'},
   {'W540', 'PC: Verdampfer V6B abgeschaltet'},
   {'W541', 'PC: Verdampfer V7A abgeschaltet'},
   {'W542', 'PC: Verdampfer V7B abgeschaltet'},
   {'W543', 'PC: Verdampfer V8A abgeschaltet'},
   {'W544', 'PC: Verdampfer V8B abgeschaltet'},
   {'W545', 'PC: Verdampfer V9A abgeschaltet'},
   {'W546', 'PC: Verdampfer V9B abgeschaltet'},
   {'W547', 'PC: Verdampfer V10A abgeschaltet'},
   {'W548', 'PC: Verdampfer V10B abgeschaltet'},
   {'W549', 'PC: Verdampfer V11A abgeschaltet'},
   {'W550', 'PC: Verdampfer V11B abgeschaltet'},
   {'W551', 'PC: Verdampfer V12A abgeschaltet'},
   {'W552', 'PC: Verdampfer V12B abgeschaltet'},
   {'W553', 'PC: Verdampfer V13A abgeschaltet'},
   {'W554', 'PC: Verdampfer V13B abgeschaltet'},
   {'W555', 'PC: Verdampfer V14A abgeschaltet'},
   {'W556', 'PC: Verdampfer V14B abgeschaltet'},
   {'W557', 'PC: Verdampfer V15A abgeschaltet'},
   {'W558', 'PC: Verdampfer V15B abgeschaltet'},
   {'W559', 'PC: Verdampfer V16A abgeschaltet'},
   {'W560', 'PC: Verdampfer V16B abgeschaltet'},
   {'W561', 'PC: Triggertest fehlgeschlagen'},
   {'F562', 'PC: Biastest fehlgeschlagen'},
   {'F563', 'PC: Lecktest fehlgeschlagen: Leckrate zu hoch'},
   {'F564', 'PC: Enddruck nach dem Heizen zu hoch'},
   {'W565', 'PC: Der Autozero von Messröhre A4 wurde aktiviert'},
   {'F566', 'PC: Prozessabbruch, Verbindung zur SPS ausgefallen'},
   {'W567', 'PC: AUX abgeschaltet'},
   {'W568', 'PC: H2 abgeschaltet'},
   {'W569', 'PC: PQ AC1 abgeschaltet'},
   {'W570', 'PC: PQ DC1 abgeschaltet'},
   {'W571', 'PC: PQ AC2 abgeschaltet'},
   {'W572', 'PC: PQ DC2 abgeschaltet'},
   {'W573', 'PC: Wartezeit dauert zu lange!'},
   {'W574', 'PC: Prozess beendet'},
   {'W575', 'PC: Ar-3 abgeschaltet'},
   {'W576', 'PC: Enddruck nach dem Prozess zu hoch'}
}

local pumps = {'Hochvakuum', 'Grobvakuum', 'Standby', 'Belüften'}
local recipes = {
   [00] = 'KeineRezept',
   [20] = 'Warten_auf_Autostart',
   [22] = 'Warten_auf_Kaltwasser',
   [30] = 'Warten_auf_Biastest',
   [40] = 'Start_Lecktest',
   [50] = 'Warten_auf_Heizen',
   [52] = 'Heizen',
   [60] = 'Warten_auf_glow_discharge',
   [62] = 'Glow_discharge',
   [70] = 'Warte_auf_Plasmanitrieren',
   [72] = 'Plasmanitrieren',
   [80] = 'Warten_auf_sputter_cleaning_N2',
   [86] = 'Warten_auf_sputter_cleaning',
   [90] = 'Warten_auf_Beschichten',
   [92] = 'Beschichten',
   [100] = 'Bestimmen_Endvakuum',
   [101] = 'Barathron_auto_zero',
   [102] = '5_Sekunden_bis_Belüften_oder_Vakuumpumpen',
   [10] = 'Triggertest',
   [114] = 'Warte_Drehantribe_aus',
   [122] = ' Warten_auf_Aufzeichnungsende'
}

local server
local timer
local socks = {}
local bufs = {}
local devices = {}
local alarmbits = {}
local fmt = '<acdata>%W*<name>%s*([%a%d_]+)%s*</name>%W*<datatype>%s*%w+%s*</datatype>%W*<type>%s*[%d%a_]+%s*</type>%W*<value>%s*(.-)%s*</value>'


local function getChildDeviceID(serial)
   if devices[serial] then return devices[serial] end
   http:clear()
   if http:post('300,' .. serial) <= 0 then return nil end
   local resp = http:response()
   if string.sub(resp, 1, 2) == "50" then
      http:clear()
      if http:post('351,' .. 'Eifeler (' .. serial .. '),' .. serial) <= 0 then
         return nil
      end
      resp = http:response()
      if string.sub(resp, 1, 3) == '887' then
         local ID = string.match(resp, '%d+,%d+,(%d+)')
         local msg = '302,'..ID..','..serial..'\n342,'..c8y.ID..','..ID
         if http:post(msg) < 0 then return nil end
         devices[serial] = ID
         alarmbits[ID] = {}
         return ID
      end
   elseif string.sub(resp, 1, 3) == "800" then
      return string.match(resp, "%d+,%d+,(%d+)")
   end
   return nil
end

local function noramlizeValue(value)
   local normalized, count = value:gsub(",", ".", 1)
   return normalized
end

local function parse(buf)
   local index, stop = 1, 1
   local tbl = {}
   while true do
      local _, stop, name, value = string.find(buf, fmt, index)
      if not name then break end
      tbl[name] = noramlizeValue(value)
      index = stop
   end
   local serial = tbl['Anlagenname']
   if not serial then return index end
   local ID = getChildDeviceID(serial)
   if not ID then
      srError('Eifeler: get Device ID failed')
      return 1
   end

   tbl['Anlagenname'] = nil
   local req = {}
   local now = utcTime()
   local cleared = false
   for k, v in pairs(tbl) do
      if k == 'Rezeptmodus' then
         req[#req + 1] = '356,'..ID..','..k..','..(recipes[tonumber(v)] or v)
      elseif k == 'Alarmmeldungen' then
         srDebug(string.format('Eifeler: alarmmeldungen[%d]: %s', #v, v))
         for i = 1, #alarms do
            local newvalue = tonumber(string.sub(v, i, i)) or 0
            if newvalue ~= alarmbits[ID][i] then
               if newvalue == 0 then
                  cleared = true
               else
                  req[#req + 1] = string.format('334,%s,%d,Eifeler_%s,MAJOR,%s',
                                                now, ID, alarms[i][1]:sub(2),
                                                alarms[i][2])
               end
               alarmbits[ID][i] = newvalue
            end
         end
      elseif k == 'Pumpmodus' then
         req[#req + 1] = '356,'..ID..','..k..','..(pumps[v + 1] or v)
      elseif string.sub(k, 1, 10) == 'Temperatur' then
         req[#req + 1] = string.format('352,%s,%s,%s,%s', now, ID, k, v)
      elseif string.sub(k, 1, 7) == 'Prozess' then
         req[#req + 1] = string.format('353,%s,%s,%s,%s', now, ID, k, v)
      elseif string.sub(k, 1, 8) == 'Leitwert' then
         req[#req + 1] = string.format('354,%s,%s,%s', now, ID, v)
      elseif string.sub(k, 1, 7) == 'Energie' then
         req[#req + 1] = string.format('355,%s,%s,%s', now, ID, v)
      else
         req[#req + 1] = '356,'..ID..','..k..','..v
      end
      index = stop
   end
   if cleared then
      req[#req + 1] = string.format('311,' .. ID .. ',ACTIVE\n311,'
                                       .. ID .. ',ACKNOWLEDGED')
   end
   if #req ~= 0 then c8y:send(table.concat(req, '\n')) end
   return index
end


function poll()
   local rds = socket.select(socks, nil, 0.1)
   if rds[server] then
      local client = server:accept()
      if client then
         client:settimeout(1)
         table.insert(socks, client)
         table.insert(bufs, '')
         srInfo('Eifeler: new client ' .. client:getpeername())
      else
         srWarning('Eifeler: accept: error')
      end
   end
   local rms = {}
   for i = 2, #socks do
      if rds[socks[i]] then
         local all, err, partial = socks[i]:receive('*a')
         if all then
            bufs[i] = bufs[i] .. all
            table.insert(rms, i)
         elseif err == 'timeout' then
            bufs[i] = bufs[i] .. partial
         else
            srWarning('Eifeler: error: ' .. err)
            table.insert(rms, i)
         end
         local idx = parse(bufs[i])
         bufs[i] = string.sub(bufs[i], idx)
      end
   end
   for i = #rms, 1, -1 do
      table.remove(socks, rms[i])
      table.remove(bufs, rms[i])
   end
end


function addDevice(r)
   devices[r:value(3)] = r:value(2)
   alarmbits[r:value(2)] = {}
end


function clearAlarm(r)
   local idx = tonumber(string.sub(r:value(3), 9))
   if idx and alarmbits[r:value(4)][idx] ~= 1 then
      c8y:send('313,' .. r:value(2))
   end
end


function init()
   c8y:addMsgHandler(888, 'addDevice')
   c8y:addMsgHandler(889, 'clearAlarm')
   timer = c8y:addTimer(1000, 'poll')
   local port = rdbGetInt('service.cumulocity.eifeler.port')
   srNotice('Eifeler: listen on ' .. port)
   server = socket.bind('0.0.0.0', port)
   server:settimeout(5)
   table.insert(socks, server)
   table.insert(bufs, '')
   timer:start()
   return 0
end
